if(!exists('new_out')){
   new_out <- 'recfail.factor'
   new_out_short <- 'recfail'
}


# lvl_art <- c("On ART",
#              paste("Initiated within ",post_tbdx_time/7," weeks",sep=''),
#              paste("Initiated after ",post_tbdx_time/7," weeks",sep=''),
#              "No ART during TB treatment")
# art_lbl <- c(paste("ART in ",post_tbdx_time/7," weeks vs None",sep=''),
#              paste("ART after ",post_tbdx_time/7," weeks vs. None",sep=''))
# 
# lvl_art_new <- c("Active at TB Diagnosis",
#                  paste(post_tbdx_time/7," weeks or less",sep=''),
#                  paste("$> $",post_tbdx_time/7," weeks or never",sep=''))
# art_lbl_new <- c(paste("Initiated ART within ",post_tbdx_time/7," weeks vs Active at TB Diagnosis",sep=''),
#                  paste("Initiated ART $>$ ",post_tbdx_time/7," weeks or never vs. Active at TB Diagnosis",sep=''))


if(art_lvls == 4){
   lvl_art <- c('On ART',
                paste('Initiated within ',post_tbdx_time/7,' weeks',sep=''),
                paste('Initiated after ',post_tbdx_time/7,' weeks',sep=''),
               'No ART during TB treatment')
   art_lbl <- c('On ART vs. None',
                paste('ART in ',post_tbdx_time/7,' weeks vs. None',sep=''),
                paste('ART after ',post_tbdx_time/7,' weeks vs. None',sep=''))
} else if (art_lvls == 3){
   lvl_art <- levels(relevel(d1$art_status_overall.factor, ref=art_ref))
   art_lbl <- c(paste(lvl_art[2],' vs. ',lvl_art[1],sep=''),
                paste(lvl_art[3],' vs. ',lvl_art[1],sep=''))
}

if(post_tbdx_time/7 == 2){
# if(!is.null(new_art)){
#    lvl_art <- c('On ART','Initiated within 2 weeks','Initiated after 2 weeks','No ART during TB treatment')
#    art_lbl <- c('ART in 2 weeks vs. None','ART after 2 weeks vs. None')
#    rcsval_cd4 <- c(10,30)
   cd4_lbl <- 'CD4+ cell count (30 vs. 10 cells)'
} else if(post_tbdx_time/7 == 8){
#    lvl_art <- c("On ART","Initiated within 8 weeks","Initiated after 8 weeks","No ART during TB treatment")
#    art_lbl <- c('ART in 8 weeks vs. None','ART after 8 weeks vs. None')
#    rcsval_cd4 <- c(50,200)
   cd4_lbl <- 'CD4+ cell count (200 vs. 50 cells)'
}

set.seed(1)

library(ipw)
library(survey)
## to create Absolute standardized differences in unweighted and weighted samples.
## more info: https://cran.r-project.org/web/packages/tableone/vignettes/smd.html
library(tableone) 
## Reorganizing data
library(reshape2)
## plotting
library(ggplot2)
## for deltamethod
library(msm) 
## for grid.arrange
library(gridExtra)

# if(art_lvls == 4){
#    data_new <- idata
# } else if(art_lvls == 3){
#    data_new <- idata_new
# }

# # idata2 <- merge(idata,d1[c("patient","recfail.factor")])
# idata2 <- merge(idata,d1[c("patient",new_out)])
idata2 <- merge(idata,d1[c("patient",new_out)])

# df2 <- merge(df1,d1[c("patient","recfail.factor")])
df2 <- merge(df1,d1[c("patient",new_out)])

if(new_out == 'recfail.factor'){
   idata2$recfail <- as.numeric(idata2$recfail.factor=="Recurrence/Failure")
   df2$recfail <- as.numeric(df2$recfail.factor=="Recurrence/Failure")
} else if(new_out == 'death_y.factor'){
   idata2[[new_out_short]] <- as.numeric(idata2[[new_out]]=='Died')
   df2[[new_out_short]] <- as.numeric(df2[[new_out]]=='Died')
} else if(new_out == 'combined_outcome.factor'){
   idata2[[new_out_short]] <- as.numeric(idata2[[new_out]] == 'Yes')
   df2[[new_out_short]] <- as.numeric(df2[[new_out]] == 'Yes')
}

removercs <- function(x) gsub("rcs(","",gsub(",3)","",x,fixed=TRUE),fixed=TRUE)

idata2$dot <- ifelse(idata2$dot.partial==1,2,ifelse(idata2$dot.complete,3,1))
idata2$dot <- factor(idata2$dot,1:3,c("None","Partial","Complete"))

if(art_lvls == 4){
   idata2$art <- ifelse(idata2$art1==1,1,ifelse(idata2$art2,2,ifelse(idata2$art3==1,3,4)))
   idata2$art <- factor(idata2$art,1:4,lvl_art)
} else if(art_lvls == 3){
   idata2$art_status_overall.factor <- ifelse(idata2$art_bf_xwks == 1,'Active at TB Diagnosis',
                                          ifelse(idata2$art_within_xwks == 1,paste(post_tbdx_time/7,' weeks or less',sep=''),
                                             ifelse(idata2$art_gt_xwks == 1,paste('$>$ ',post_tbdx_time/7,' weeks or never',sep=''),NA)))
   idata2$art_status_overall.factor <- factor(idata2$art_status_overall.factor, 
                                              levels=c(art_ref,
                                                       setdiff(c('Active at TB Diagnosis',
                                                                 paste(post_tbdx_time/7,' weeks or less',sep=''),
                                                                 paste('$>$ ',post_tbdx_time/7,' weeks or never',sep='')),
                                                               art_ref)))
}

idata2$bmidelta <- idata2$bmi2-idata2$bmi1
idata2$weightdelta <- idata2$weight2-idata2$weight1


dd <- datadist(idata2)
options(datadist='dd')

## i had to remove the "impute" class assignment for CreateTableOne() to work
for(i in 1:ncol(idata2)){
  if(length(attr(idata2[,i],"class"))>0){
    if(attr(idata2[,i],"class") %in% "impute") attr(idata2[,i],"class") <- NULL
  }
}

idata2$year_tbdx_cat.factor <- ifelse(idata2$year_tbdx_cat.factor == 1,'2012',
                                      ifelse(idata2$year_tbdx_cat.factor == 2,'2013',
                                             as.character(idata2$year_tbdx_cat.factor)))
idata2$year_tbdx_cat.factor <- factor(idata2$year_tbdx_cat.factor, levels=c('2012','2013'))

######### FUNCTIONS FOR SUMMARIZING VARIABLES EXPANDED USING RESTRICTED CUBIC SPLINES ##########
######### FUNCTIONS FOR SUMMARIZING VARIABLES EXPANDED USING RESTRICTED CUBIC SPLINES ##########
######### FUNCTIONS FOR SUMMARIZING VARIABLES EXPANDED USING RESTRICTED CUBIC SPLINES ##########
ispos <- function(var){ifelse(var>0,var,0)}  ## FUNCTION (2.18) FROM PAGE 18 of FRANK'S BOOK
# number of knots
k <- 3
statabetweenknots <- function(j,rcsvar,ourknots){
  (ispos(rcsvar-ourknots[j])^3- (ourknots[k] - ourknots[k-1])^(-1)*(ispos(rcsvar-ourknots[k-1])^3*(ourknots[k] - ourknots[j]) - ispos(rcsvar-ourknots[k])^3*(ourknots[k-1] - ourknots[j])))/(ourknots[k] - ourknots[1])^2
}  ## FUNCTION FROM STATA MANUEL MKSPLINE()
######### FUNCTIONS FOR SUMMARIZING VARIABLES EXPANDED USING RESTRICTED CUBIC SPLINES ##########
######### FUNCTIONS FOR SUMMARIZING VARIABLES EXPANDED USING RESTRICTED CUBIC SPLINES ##########
######### FUNCTIONS FOR SUMMARIZING VARIABLES EXPANDED USING RESTRICTED CUBIC SPLINES ##########


getipw <- function(var,out,rcsval=rcsval,family="ordinal',link='logit"){
  # out <- "rcs(age,3)"
  ## write formula
#   f2 <- paste0("recfail~",out)
  f2 <- paste0(new_out_short,'~',out)

  estwts <- eval(parse(text=paste0("ipwpoint(exposure = ",removercs(out),
    ",family = '",family,"',numerator = ~ 1,denominator = ~ ",
    paste(var,collapse="+"),
    ",data = idata2, trunc=0.01)")))
    
  # summary(estwts$num.mod)
  # summary(estwts$den.mod)
  # ipwplot(weights = estwts$ipw.weights, logscale = FALSE,
  #         main = "Stabilized weights", xlim = c(0, 8))
  #Paste inverse probability weights

#   # ----------------------------------------- #
#   # 11/27/2018:  Adding in truncating weights at the 1st and 99th percentiles:
#   sw_percentiles <- quantile(estwts$ipw.weights, probs=c(0.01, 0.99))
#   estwts$ipw.weights.truncated <- ifelse(estwts$ipw.weights < sw_percentiles[1], sw_percentiles[1],
#                                          ifelse(estwts$ipw.weights > sw_percentiles[2], sw_percentiles[2],
#                                                 estwts$ipw.weights))
#   estwts$ipw.weights.original <- estwts$ipw.weights
#   estwts$ipw.weights <- estwtw$ipw.weights.truncated
#   # ----------------------------------------- #

#   # 11/27/2018:  Adding in truncating weights at the 1st and 99th percentiles:
#   idata2$sw <- estwts$ipw.weights
  idata2$sw <- estwts$weights.trunc

  wm1 <- (svyglm(f2, design = svydesign(~ 1, weights = ~ sw, data = idata2), family=quasibinomial()))
  if(family %in% c("gaussian","ordinal',link='logit")) idata2$strata <- ifelse(get(removercs(out),idata2)>median(get(removercs(out),idata2)),"High","Low")
  if(family!="ordinal',link='logit" & family!="gaussian" & family!="multinomial") idata2$strata <- get(removercs(out),idata2)
  if(family=="multinomial") idata2$strata <- ifelse(get(removercs(out),idata2)==levels(get(removercs(out),idata2))[1],levels(get(removercs(out),idata2))[1],"Other")
  
  ## Weighted data
  idata2Svy <- svydesign(ids = ~ 1, data = idata2, weights = ~ sw)
  
  tabUnmatched <- CreateTableOne(vars = removercs(c(out,var)), strata = "strata", data = idata2, test = FALSE)
  tabWeighted <- svyCreateTableOne(vars = removercs(c(out,var)), strata = "strata", data = idata2Svy, test = FALSE)
  
  ## Construct a data frame containing variable name and SMD from all methods
  dataPlot <- data.frame(variable  = names(ExtractSmd(tabUnmatched)),
                         Unmatched = ExtractSmd(tabUnmatched),
                         Weighted  = ExtractSmd(tabWeighted))
  
  ## Create long-format data for ggplot2
  dataPlotMelt <- melt(data          = dataPlot,
                       id.vars       = c("variable"),
                       variable.name = "Method",
                       value.name    = "SMD")
  
  ## Order variable names by magnitude of SMD
  varNames <- as.character(dataPlot$variable)[order(dataPlot$Unmatched)]
  
  ## Order factor levels in the same order
  dataPlotMelt$variable <- factor(dataPlotMelt$variable,
                                  levels = varNames)
  
  ## Plot using ggplot2
  smd.plot <- ggplot(data = dataPlotMelt, mapping = aes(x = variable, y = SMD,
                                            group = Method, color = Method)) +
    geom_line() +
    geom_point() +
    geom_hline(yintercept = 0.1, color = "black", size = 0.1) +
    coord_flip() +
    theme_bw() + theme(legend.key = element_rect(),legend.background = element_rect(fill = "transparent"),
                       legend.position=c(0.8,0.2), legend.text=element_text(size=8),legend.title=element_blank())
  
  
  if(!grepl("rcs",out)){
    est <- coefficients(wm1)[-1]
    se <- sqrt(diag(vcov(wm1)))[-1]
    rcs.plot <- NULL
  }
  
  ## now if there is an rcs on the key covariate
  if(grepl("rcs",out)){
    b <- coefficients(wm1)
    ourknots <- quantile(idata2[removercs(out)],probs=c(0.1,0.5,0.9),na.rm=TRUE)  ## PAGE 23 FROM FRANK HARREL'S BOOK
    
    ###### including all parameters
    # rcsval <- c(30,40)
    X1 <- data.frame(Int=1,rcsval[1],statabetweenknots(1,rcsval[1],ourknots))
    X2 <- data.frame(Int=1,rcsval[2],statabetweenknots(1,rcsval[2],ourknots))
    x1 <- paste(X1,"*x",1:length(X1),sep="",collapse="-")
    x2 <- paste(X2,"*x",1:length(X2),sep="",collapse="-")
    est <- (-as.numeric(X1) %*% b)-(-as.numeric(X2) %*% b)
    se <- deltamethod(formula(paste0("~(",x1,")-(",x2,")")),coefficients(wm1),vcov(wm1))
    
    ## THE ADJUSTMENTS WILL MATTER HERE (BUT NOT ABOVE)
    rcsvar <- dd$limits[removercs(out)][4,]:dd$limits[removercs(out)][5,]
    X <- data.frame(Int=1,rcsvar,statabetweenknots(1,rcsvar,ourknots))

    rcsvar.se <- rcsvar.est <- NULL
    for(i in 1:nrow(X)){
      x <- paste(X[i,],"*x",1:ncol(X),sep="",collapse="-")
      rcsvar.est <- c(rcsvar.est,(as.numeric(X[i,]) %*% b))
      rcsvar.se <- c(rcsvar.se,sqrt(diag(as.numeric(X[i,])%*% vcov(wm1) %*% as.numeric(X[i,]))))
    }
    ## GET 95% CONFIDENCE INTERVAL OF LOG
    rcsvar.ll <- rcsvar.est - 1.96*rcsvar.se
    rcsvar.ul <- rcsvar.est + 1.96*rcsvar.se
    
    rcsplot <- data.frame(y=rcsvar.est,Lower=rcsvar.ll,Upper=rcsvar.ul,value=rcsvar)
    
    rcs.plot <-   xYplot(Cbind (y, Lower, Upper) ~ value, 
                         method="filled bands" , data=rcsplot, label.curves=FALSE,
                         type="l", col="blue", col.fill = gray(.8),ylab= expression(X * hat(beta)),xlab=simpleCap(removercs(out)))
  }
  sum.ests <- paste0(myformat2(exp(est))," (",myformat2(exp(est-1.96*se)),", ",myformat2(exp(est+1.96*se)),")")
  ## wm1 is the weighted regression and wm2 includes covariates (just to check for near zero coefficients)
  return(list(wm1=wm1,
              smd.plot=smd.plot,
              rcs.plot=rcs.plot,
              sum.ests=sum.ests,
              weights=idata2$sw))
}

if(art_ref == 'Active at TB Diagnosis'){
   art_vars <- c('art_within_xwks','art_gt_xwks')
} else if(art_ref == paste(post_tbdx_time/7,' weeks or less',sep='')){
   art_vars <- c('art_bf_xwks','art_gt_xwks')
} else if(art_ref == paste('$>$ ',post_tbdx_time/7,' weeks or never',sep='')){
   art_vars <- c('art_bf_xwks','art_within_xwks')
}


if(art_lvls == 4){
   source('Data_reduction_code/ipw_call_4lvl.R')
   lab1 <- c('Age (40 vs. 30 years)','Female vs. Male','BMI at start of TB treatment (21 vs. 17)','Weight at start of TB treatment (60 vs 45 kg)','Smear Positive','Culture Positive',
             'Bacteriologically Confirmed','Extrapulmonary vs. pulmonary/both/unknown',cd4_lbl,'On ART')
} else if(art_lvls == 3){
   source('Data_reduction_code/ipw_call_3lvl.R')
}


lab2 <- c('Age (40 vs. 30 years)','Female vs. Male','BMI change (2 unit increase vs. no change)','Weight change (5 kg increase vs. no change)','Smear Positive','Culture Positive','Bacteriologically Confirmed','Extrapulmonary vs. pulmonary/both/unknown',cd4_lbl,art_lbl, 'Continuation phase TB therapy DOT vs. None')

#lab2b <- c('Age (40 vs. 30 years)','Female vs. Male','BMI change (2 unit increase vs. no change)','Weight change (5 kg increase vs. no change)','Smear Positive','Culture Positive','Bacteriologically Confirmed','Extrapulmonary vs. pulmonary/both/unknown',cd4_lbl,art_lbl, 'Intensive phase DOT only','Intensive and continuation phase DOT')

if(post_tbdx_time/7 == 8){
   if(art_lvls == 4){
      est1 <- c(age1$sum.ests,sex1$sum.ests,bmi1$sum.ests,wt1$sum.ests,smearpos1$sum.ests,culturepos1$sum.ests,
                baccon1$sum.ests,extra1$sum.ests,cd41$sum.ests,art1$sum.ests)
   }
   est2 <- c(age2$sum.ests,sex2$sum.ests,bmi2$sum.ests,wt2$sum.ests,smearpos2$sum.ests,culturepos2$sum.ests,
             baccon2$sum.ests,extra2$sum.ests,cd42$sum.ests,art2$sum.ests,dot2_continuation$sum.ests)
#   est2b <- c(age2$sum.ests,sex2$sum.ests,bmi2$sum.ests,wt2$sum.ests,smearpos2$sum.ests,culturepos2$sum.ests,
#              baccon2$sum.ests,extra2$sum.ests,cd42$sum.ests,art2$sum.ests,dot2_combined$sum.ests)

} else if(post_tbdx_time/7 == 2){
   if(art_lvls == 4){
      est1 <- c(age1$sum.ests,sex1$sum.ests,bmi1$sum.ests,wt1$sum.ests,smearpos1$sum.ests,culturepos1$sum.ests,
                baccon1$sum.ests,extra1$sum.ests,cd43$sum.ests,art1$sum.ests)
   }
   est2 <- c(age2$sum.ests,sex2$sum.ests,bmi2$sum.ests,wt2$sum.ests,smearpos2$sum.ests,culturepos2$sum.ests,
             baccon2$sum.ests,extra2$sum.ests,cd44$sum.ests,art2$sum.ests,dot2_continuation$sum.ests)
#   est2b <- c(age2$sum.ests,sex2$sum.ests,bmi2$sum.ests,wt2$sum.ests,smearpos2$sum.ests,culturepos2$sum.ests,
#              baccon2$sum.ests,extra2$sum.ests,cd44$sum.ests,art2$sum.ests,dot2_combined$sum.ests)

}

if(art_lvls == 4){
   ipw1table <- paste(paste(lab1,est1,sep=" & "),collapse=" \\\\ ")
}
ipw2table <- paste(paste(lab2,est2,sep=" & "),collapse=" \\\\ ")

#ipw2btable <- paste(paste(lab2b,est2b,sep=" & "),collapse=" \\\\ ")


# smdplot1 <- grid.arrange(age1$smd.plot,sex1$smd.plot,bmi1$smd.plot,wt1$smd.plot,smearpos1$smd.plot,culturepos1$smd.plot,
#                          baccon1$smd.plot,extra1$smd.plot,cd41$smd.plot,art1$smd.plot)
# smdplot2 <- grid.arrange(age2$smd.plot,sex2$smd.plot,bmi2$smd.plot,wt2$smd.plot,smearpos2$smd.plot,culturepos2$smd.plot,
#                          baccon2$smd.plot,extra2$smd.plot,cd42$smd.plot,art2$smd.plot,dot2$smd.plot)
# 
# rcsplot1 <- grid.arrange(age1$rcs.plot,bmi1$rcs.plot,wt1$rcs.plot,cd41$rcs.plot)
# rcsplot2 <- grid.arrange(age2$rcs.plot,bmi2$rcs.plot,wt2$rcs.plot,cd42$rcs.plot)
