# region (now site) and age_tbdx_cat.factor added 3/8/18 per April's request:
# And now both site/region removed and using region-wide DOT variables

age2 <- getipw(var=c('female','rcs(bmi1,3)','smearpos','culturepos','baccon','extrapulm','rcs(cd4,3)','dot_continuation',art_vars,'rcs(bmi2,3)','year_tbdx_cat.factor','region'),
               out="rcs(age,3)",rcsval=c(30,40))

sex2 <- getipw(var=c('rcs(age,3)','rcs(bmi1,3)','smearpos','culturepos','baccon','extrapulm','rcs(cd4,3)','dot_continuation',art_vars,'rcs(bmi2,3)','year_tbdx_cat.factor','region'),
               out="female",family="binomial',link='logit")

bmi2 <- getipw(var=c('rcs(age,3)','female','rcs(bmi1,3)','smearpos','culturepos','baccon','extrapulm','rcs(cd4,3)','dot_continuation',art_vars,'year_tbdx_cat.factor','region'),
                 out="rcs(bmidelta,3)",rcsval=c(0,2),family="gaussian") ## family='ordinal' is giving errors

wt2 <- getipw(var=c('rcs(age,3)','female','weight1','smearpos','culturepos','baccon','extrapulm','rcs(cd4,3)','dot_continuation',art_vars,'year_tbdx_cat.factor','region'),
              out="rcs(weightdelta,3)",rcsval=c(0,5),family="gaussian") ## family='ordinal' is giving errors (i wonder if it's the negative values?)

smearpos2 <- getipw(var=c('rcs(age,3)','female','rcs(bmi1,3)','extrapulm','rcs(cd4,3)','dot_continuation',art_vars,'rcs(bmi2,3)','year_tbdx_cat.factor','region'),
                    out="smearpos",family="binomial',link='logit")

culturepos2 <- getipw(var=c('rcs(age,3)','female','rcs(bmi1,3)','extrapulm','rcs(cd4,3)','dot_continuation',art_vars,'rcs(bmi2,3)','year_tbdx_cat.factor','region'),
                      out="culturepos",family="binomial',link='logit")

baccon2 <- getipw(var=c('rcs(age,3)','female','rcs(bmi1,3)','extrapulm','rcs(cd4,3)','dot_continuation',art_vars,'rcs(bmi2,3)','year_tbdx_cat.factor','region'),
                  out="baccon",family="binomial',link='logit")

extra2 <- getipw(var=c('rcs(age,3)','female','rcs(bmi1,3)','smearpos','culturepos','baccon','rcs(cd4,3)','dot_continuation',art_vars,'rcs(bmi2,3)',
                       'year_tbdx_cat.factor','region'),
                 out="extrapulm",family="binomial',link='logit")

cd42 <- getipw(var=c('rcs(age,3)','female','rcs(bmi1,3)','smearpos','culturepos','baccon','extrapulm','dot_continuation',art_vars,'rcs(bmi2,3)','year_tbdx_cat.factor','region'),
               out="rcs(cd4,3)",rcsval=c(50,200))

cd44 <- getipw(var=c('rcs(age,3)','female','rcs(bmi1,3)','smearpos','culturepos','baccon','extrapulm','dot_continuation',art_vars,'rcs(bmi2,3)','year_tbdx_cat.factor','region'),
               out="rcs(cd4,3)",rcsval=c(10,30))

## use this for ART at diagnosis and ART timing
art2 <- getipw(var=c('rcs(age,3)','female','rcs(bmi1,3)','smearpos','culturepos','baccon','extrapulm','rcs(cd4,3)','dot_continuation','rcs(bmi2,3)',
                     'year_tbdx_cat.factor','region'),
                  out="art_status_overall.factor",family="multinomial") # was originall art -- is that a factor???

# dot2 <- getipw(var=c('rcs(age,3)','female','rcs(bmi1,3)','smearpos','culturepos','baccon','extrapulm','rcs(cd4,3)',art_vars,'rcs(bmi2,3)','year_tbdx_cat.factor','region'),
#                out="dot",family="multinomial")

#dot2_intensive <- getipw(var=c('rcs(age,3)','female','rcs(bmi1,3)','smearpos','culturepos','baccon','extrapulm','rcs(cd4,3)',art_vars,'rcs(bmi2,3)','year_tbdx_cat.factor','region'),
#                         out="dot_intensive",family="binomial',link='logit")
dot2_continuation <- getipw(var=c('rcs(age,3)','female','rcs(bmi1,3)','smearpos','culturepos','baccon','extrapulm','rcs(cd4,3)',art_vars,'rcs(bmi2,3)','year_tbdx_cat.factor','region'),
                            out="dot_continuation",family="binomial',link='logit")

#dot2_intensive_wo_region <- getipw(var=c('rcs(age,3)','female','rcs(bmi1,3)','smearpos','culturepos','baccon','extrapulm','rcs(cd4,3)',art_vars,'rcs(bmi2,3)','year_tbdx_cat.factor'),
#                                   out="dot_intensive",family="binomial',link='logit")
dot2_continuation_wo_region <- getipw(var=c('rcs(age,3)','female','rcs(bmi1,3)','smearpos','culturepos','baccon','extrapulm','rcs(cd4,3)',art_vars,'rcs(bmi2,3)','year_tbdx_cat.factor'),
                                      out="dot_continuation",family="binomial',link='logit")

#idata2$dot_combined <- ifelse(idata2$dot_intensive == 0 & idata2$dot_continuation == 0,0,
#                              ifelse(idata2$dot_intensive == 1 & idata2$dot_continuation == 0,1,
#                              ifelse(idata2$dot_intensive == 0 & idata2$dot_continuation == 1,2,
#                              ifelse(idata2$dot_intensive == 1 & idata2$dot_continuation == 1,3,NA))))
#idata2$dot_combined <- as.factor(idata2$dot_combined)

#dot2_combined <- getipw(var=c('rcs(age,3)','female','rcs(bmi1,3)','smearpos','culturepos','baccon','extrapulm','rcs(cd4,3)',art_vars,'rcs(bmi2,3)','year_tbdx_cat.factor','region'),
#                        out="dot_combined",family="multinomial")


# ## Added 3/8/18 per April's request to also adjust for region (now site) and year of TB dx (have to do this categorically)
# region2 <- getipw(var=c('rcs(age,3)', 'female', 'rcs(bmi1,3)', 'smearpos', 'culturepos', 'baccon', 'extrapulm', 'rcs(cd4,3)', 'dot.partial', 'dot.complete', art_vars, 'rcs(bmi2,3)',
#                         'year_tbdx_cat.factor'),
#                   out="region",family="multinomial")
# year2 <- getipw(var=c('rcs(age,3)', 'female', 'rcs(bmi1,3)', 'smearpos', 'culturepos', 'baccon', 'extrapulm', 'rcs(cd4,3)', 'dot.partial', 'dot.complete', art_vars, 'rcs(bmi2,3)',
#                         'region'),
#                 out="year_tbdx_cat.factor",family="binomial, link='logit'")