# Adding in REDCap data on death:
#  Comprises 2 variables:  tt_outcome and x28...death..due.to.any.cause..not.only.due.to.TB. (I named it death_from_rcd; this differs
#  from death_y_from_rcd which is the combined death_y and all the other death variable information
tt_outcome <- apply(rcd[which(rcd$redcap.id.number..automatically.generated. %in% d4$REDCap.ID.Number..automatically.generated.),tt_outcome_vars], 1, 
                  FUN=function(y){paste(names(y)[which(y == 'Checked')],collapse=',')})

d4$tt_outcome <- tt_outcome
d4$death_from_rcd <- rcd[match(d4$REDCap.ID.Number..automatically.generated., rcd$redcap.id.number..automatically.generated., nomatch=NA),'x28...death..due.to.any.cause..not.only.due.to.tb.']
d4$death_date_from_rcd <- rcd[match(d4$REDCap.ID.Number..automatically.generated., rcd$redcap.id.number..automatically.generated., nomatch=NA),'x28...death.date']
d4$death_date_from_rcd <- as.Date(d4$death_date_from_rcd, format='%m/%d/%Y')

d4$death_y_from_rcd <- ifelse(d4$tt_outcome %in% c('Completed,Death during TB trt','Death during TB trt','Death during TB trt,Trt interrupted'),1,d4$death_y)
d4$death_y_from_rcd <- ifelse(d4$death_from_rcd %in% c('Yes','Oui'),1,
                              ifelse(d4$death_from_rcd %in% c('Alive','Non'),0,d4$death_y_from_rcd))
d4$death_y_from_rcd <- ifelse(d4$death_from_rcd == 'Alive',0,d4$death_y_from_rcd)
d4$death_y_from_rcd <- ifelse(!is.na(d4$death_date_from_rcd),1,d4$death_y_from_rcd)
d4$death_y_from_rcd <- ifelse(!is.na(d4$death_d),1,d4$death_y_from_rcd)

# Overwrite death_y with death_y_from_rcd
d4$death_y_old <- d4$death_y
d4$death_y <- d4$death_y_from_rcd
